Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/DNG.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/DNG.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/DNG.pm	(revision 34921)
@@ -18,5 +18,5 @@
 use Image::ExifTool::CanonRaw;
 
-$VERSION = '1.15';
+$VERSION = '1.23';
 
 sub ProcessOriginalRaw($$$);
@@ -49,5 +49,5 @@
 
 %Image::ExifTool::DNG::AdobeData = ( #PH
-    GROUPS => { 0 => 'MakerNotes', 1 => 'Adobe', 2 => 'Image' },
+    GROUPS => { 0 => 'MakerNotes', 1 => 'AdobeDNG', 2 => 'Image' },
     PROCESS_PROC => \&ProcessAdobeData,
     WRITE_PROC => \&WriteAdobeStuff,
@@ -144,5 +144,5 @@
 sub ProcessOriginalRaw($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $start = $$dirInfo{DirStart};
@@ -156,5 +156,5 @@
         my $val = Get32u($dataPt, $pos);
         $val or $pos += 4, next; # ignore zero values
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $index);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $index);
         $tagInfo or $err = "Missing DNG tag $index", last;
         if ($index & 0x02) {
@@ -169,8 +169,9 @@
             my $tag = $$tagInfo{Name};
             # only extract this information if requested (because it takes time)
-            if ($exifTool->{OPTIONS}->{Binary} or
-                $exifTool->{REQ_TAG_LOOKUP}->{lc($tag)})
+            my $lcTag = lc $tag;
+            if (($$et{OPTIONS}{Binary} and not $$et{EXCL_TAG_LOOKUP}{$lcTag}) or
+                $$et{REQ_TAG_LOOKUP}{$lcTag})
             {
-                unless (eval 'require Compress::Zlib') {
+                unless (eval { require Compress::Zlib }) {
                     $err = 'Install Compress::Zlib to extract compressed images';
                     last;
@@ -208,7 +209,7 @@
             }
         }
-        $exifTool->FoundTag($tagInfo, $val);
-    }
-    $exifTool->Warn($err || 'Bad OriginalRawFileData') if defined $err;
+        $et->FoundTag($tagInfo, $val);
+    }
+    $et->Warn($err || 'Bad OriginalRawFileData') if defined $err;
     return 1;
 }
@@ -220,5 +221,5 @@
 sub ProcessAdobeData($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dataPos = $$dirInfo{DataPos};
@@ -226,15 +227,15 @@
     my $end = $$dirInfo{DirLen} + $pos;
     my $outfile = $$dirInfo{OutFile};
-    my $verbose = $exifTool->Options('Verbose');
-    my $htmlDump = $exifTool->Options('HtmlDump');
+    my $verbose = $et->Options('Verbose');
+    my $htmlDump = $et->Options('HtmlDump');
 
     return 0 unless $$dataPt =~ /^Adobe\0/;
     unless ($outfile) {
-        $exifTool->VerboseDir($dirInfo);
+        $et->VerboseDir($dirInfo);
         # don't parse makernotes if FastScan > 1
-        my $fast = $exifTool->Options('FastScan');
+        my $fast = $et->Options('FastScan');
         return 1 if $fast and $fast > 1;
     }
-    $htmlDump and $exifTool->HDump($dataPos, 6, 'Adobe DNGPrivateData header');
+    $htmlDump and $et->HDump($dataPos, 6, 'Adobe DNGPrivateData header');
     SetByteOrder('MM'); # always big endian
     $pos += 6;
@@ -247,13 +248,13 @@
             my $name = "Adobe$tag";
             $name =~ tr/ //d;
-            $exifTool->HDump($dataPos + $pos - 8, 8, "$name header", "Data Size: $size bytes");
+            $et->HDump($dataPos + $pos - 8, 8, "$name header", "Data Size: $size bytes");
             # dump non-EXIF format data
             unless ($tag =~ /^(MakN|SR2 )$/) {
-                $exifTool->HDump($dataPos + $pos, $size, "$name data");
+                $et->HDump($dataPos + $pos, $size, "$name data");
             }
         }
         if ($verbose and not $outfile) {
-            $tagInfo or $exifTool->VPrint(0, "$$exifTool{INDENT}Unsupported DNGAdobeData record: ($tag)\n");
-            $exifTool->VerboseInfo($tag,
+            $tagInfo or $et->VPrint(0, "$$et{INDENT}Unsupported DNGAdobeData record: ($tag)\n");
+            $et->VerboseInfo($tag,
                 ref $tagInfo eq 'HASH' ? $tagInfo : undef,
                 DataPt => $dataPt,
@@ -272,5 +273,5 @@
                         $value = substr($$dataPt, $pos, $size);
                     } else {
-                        $exifTool->HandleTag($tagTablePtr, $tag, substr($$dataPt, $pos, $size));
+                        $et->HandleTag($tagTablePtr, $tag, substr($$dataPt, $pos, $size));
                     }
                     last;
@@ -295,10 +296,10 @@
             if ($outfile) {
                 $dirInfo{Proc} = $processProc;  # WriteAdobeStuff() calls this to do the actual writing
-                $value = $exifTool->WriteDirectory(\%dirInfo, $subTable, \&WriteAdobeStuff);
+                $value = $et->WriteDirectory(\%dirInfo, $subTable, \&WriteAdobeStuff);
                 # use old directory if an error occurred
                 defined $value or $value = substr($$dataPt, $pos, $size);
             } else {
                 # override process proc for MakN
-                $exifTool->ProcessDirectory(\%dirInfo, $subTable, $processProc);
+                $et->ProcessDirectory(\%dirInfo, $subTable, $processProc);
             }
             last;
@@ -313,5 +314,5 @@
         ++$pos if $size & 0x01; # (darn padding)
     }
-    $pos == $end or $exifTool->Warn("$pos $end Adobe private data is corrupt");
+    $pos == $end or $et->Warn("$pos $end Adobe private data is corrupt");
     return 1;
 }
@@ -326,10 +327,10 @@
 sub ProcessAdobeCRW($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $start = $$dirInfo{DirStart};
     my $end = $start + $$dirInfo{DirLen};
-    my $verbose = $exifTool->Options('Verbose');
-    my $buildMakerNotes = $exifTool->Options('MakerNotes');
+    my $verbose = $et->Options('Verbose');
+    my $buildMakerNotes = $et->Options('MakerNotes');
     my $outfile = $$dirInfo{OutFile};
     my ($newTags, $oldChanged);
@@ -341,14 +342,14 @@
 
     # initialize maker note data if building maker notes
-    $buildMakerNotes and Image::ExifTool::CanonRaw::InitMakerNotes($exifTool);
+    $buildMakerNotes and Image::ExifTool::CanonRaw::InitMakerNotes($et);
 
     my $entries = Get16u($dataPt, $start + 2);
     my $pos = $start + 4;
-    $exifTool->VerboseDir($dirInfo, $entries) unless $outfile;
+    $et->VerboseDir($dirInfo, $entries) unless $outfile;
     if ($outfile) {
         # get hash of new tags
-        $newTags = $exifTool->GetNewTagInfoHash($tagTablePtr);
+        $newTags = $et->GetNewTagInfoHash($tagTablePtr);
         $$outfile = substr($$dataPt, $start, 4);
-        $oldChanged = $exifTool->{CHANGED};
+        $oldChanged = $$et{CHANGED};
     }
     # loop through entries in Adobe CRW information
@@ -365,5 +366,5 @@
         my $format = $Image::ExifTool::CanonRaw::crwTagFormat{$tagType};
         my $count;
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tagID, \$value);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tagID, \$value);
         if ($tagInfo) {
             $format = $$tagInfo{Format} if $$tagInfo{Format};
@@ -405,7 +406,7 @@
                     #### eval Validate ($dirData, $subdirStart, $size)
                     if (defined $$subdir{Validate} and not eval $$subdir{Validate}) {
-                        $exifTool->Warn("Invalid $name data");
+                        $et->Warn("Invalid $name data");
                     } else {
-                        $subdir = $exifTool->WriteDirectory(\%subdirInfo, $newTagTable);
+                        $subdir = $et->WriteDirectory(\%subdirInfo, $newTagTable);
                         if (defined $subdir and length $subdir) {
                             if ($subdirStart) {
@@ -418,7 +419,7 @@
                     }
                 } elsif ($$newTags{$tagID}) {
-                    my $nvHash = $exifTool->GetNewValueHash($tagInfo);
-                    if (Image::ExifTool::IsOverwriting($nvHash, $val)) {
-                        my $newVal = Image::ExifTool::GetNewValues($nvHash);
+                    my $nvHash = $et->GetNewValueHash($tagInfo);
+                    if ($et->IsOverwriting($nvHash, $val)) {
+                        my $newVal = $et->GetNewValue($nvHash);
                         my $verboseVal;
                         $verboseVal = $newVal if $verbose > 1;
@@ -428,8 +429,8 @@
                         }
                         if (defined $newVal) {
-                            $exifTool->VerboseValue("- CanonRaw:$$tagInfo{Name}", $value);
-                            $exifTool->VerboseValue("+ CanonRaw:$$tagInfo{Name}", $verboseVal);
+                            $et->VerboseValue("- CanonRaw:$$tagInfo{Name}", $value);
+                            $et->VerboseValue("+ CanonRaw:$$tagInfo{Name}", $verboseVal);
                             $value = $newVal;
-                            ++$exifTool->{CHANGED};
+                            ++$$et{CHANGED};
                         }
                     }
@@ -441,5 +442,5 @@
             $$outfile .= Set16u($tag) . Set32u(length($value)) . $value;
         } else {
-            $exifTool->HandleTag($tagTablePtr, $tagID, $val,
+            $et->HandleTag($tagTablePtr, $tagID, $val,
                 Index   => $index,
                 DataPt  => $dataPt,
@@ -451,5 +452,5 @@
             if ($buildMakerNotes) {
                 # build maker notes information if requested
-                Image::ExifTool::CanonRaw::BuildMakerNotes($exifTool, $tagID, $tagInfo,
+                Image::ExifTool::CanonRaw::BuildMakerNotes($et, $tagID, $tagInfo,
                                                            \$value, $format, $count);
             }
@@ -457,23 +458,23 @@
         # (we lost the directory structure, but the second tag 0x0805
         # should be in the ImageDescription directory)
-        $exifTool->{DIR_NAME} = 'ImageDescription' if $tagID == 0x0805;
+        $$et{DIR_NAME} = 'ImageDescription' if $tagID == 0x0805;
         SetByteOrder('MM');
         $pos += $size;
     }
     if ($outfile and (not defined $$outfile or $index != $entries or
-        $exifTool->{CHANGED} ==  $oldChanged))
+        $$et{CHANGED} ==  $oldChanged))
     {
-        $exifTool->{CHANGED} = $oldChanged; # nothing changed
+        $$et{CHANGED} = $oldChanged; # nothing changed
         undef $$outfile;    # rewrite old directory
     }
     if ($index != $entries) {
-        $exifTool->Warn('Truncated CRW notes');
+        $et->Warn('Truncated CRW notes');
     } elsif ($pos < $end) {
-        $exifTool->Warn($end-$pos . ' extra bytes at end of CRW notes');
+        $et->Warn($end-$pos . ' extra bytes at end of CRW notes');
     }
     # finish building maker notes if necessary
     if ($buildMakerNotes) {
         SetByteOrder($byteOrder);
-        Image::ExifTool::CanonRaw::SaveMakerNotes($exifTool);
+        Image::ExifTool::CanonRaw::SaveMakerNotes($et);
     }
     return 1;
@@ -487,5 +488,5 @@
 sub ProcessAdobeMRW($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirLen = $$dirInfo{DirLen};
@@ -499,5 +500,5 @@
     my $raf = new File::RandomAccess(\$buff);
     my %dirInfo = ( RAF => $raf, OutFile => $outfile );
-    my $rtnVal = Image::ExifTool::MinoltaRaw::ProcessMRW($exifTool, \%dirInfo);
+    my $rtnVal = Image::ExifTool::MinoltaRaw::ProcessMRW($et, \%dirInfo);
     if ($outfile and defined $$outfile and length $$outfile) {
         # remove MRW header and add Adobe header
@@ -513,5 +514,5 @@
 sub ProcessAdobeRAF($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     return 0 if $$dirInfo{OutFile}; # (can't write this yet)
     my $dataPt = $$dirInfo{DataPt};
@@ -524,8 +525,8 @@
         $pos += 2;
     } else {
-        $exifTool->Warn('Invalid DNG RAF data');
+        $et->Warn('Invalid DNG RAF data');
         return 0;
     }
-    $exifTool->VerboseDir($dirInfo);
+    $et->VerboseDir($dirInfo);
     # make fake RAF object for processing (same acronym, different meaning)
     my $raf = new File::RandomAccess($dataPt);
@@ -545,10 +546,10 @@
             DirStart => $pos - $len,
         );
-        $$exifTool{SET_GROUP1} = "RAF$num";
-        $exifTool->ProcessDirectory(\%dirInfo, $tagTablePtr) or $warn = 1;
-        delete $$exifTool{SET_GROUP1};
+        $$et{SET_GROUP1} = "RAF$num";
+        $et->ProcessDirectory(\%dirInfo, $tagTablePtr) or $warn = 1;
+        delete $$et{SET_GROUP1};
         $num = ($num || 1) + 1;
     }
-    $warn and $exifTool->Warn('Possibly corrupt RAF information');
+    $warn and $et->Warn('Possibly corrupt RAF information');
     return 1;
 }
@@ -561,5 +562,5 @@
 sub ProcessAdobeSR2($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     return 0 if $$dirInfo{OutFile}; # (can't write this yet)
     my $dataPt = $$dirInfo{DataPt};
@@ -572,5 +573,5 @@
     return 0 unless SetByteOrder(substr($$dataPt, $start, 2));
 
-    $exifTool->VerboseDir($dirInfo);
+    $et->VerboseDir($dirInfo);
     my $dataPos = $$dirInfo{DataPos};
     my $dirStart = $start + 6;  # pointer to maker note directory
@@ -589,9 +590,9 @@
         Parent    => $$dirInfo{DirName},
     );
-    if ($exifTool->Options('HtmlDump')) {
-        $exifTool->HDump($dataPos + $start, 6, 'Adobe SR2 data');
+    if ($et->Options('HtmlDump')) {
+        $et->HDump($dataPos + $start, 6, 'Adobe SR2 data');
     }
     # parse the SR2 directory
-    $exifTool->ProcessDirectory(\%subdirInfo, $tagTablePtr);
+    $et->ProcessDirectory(\%subdirInfo, $tagTablePtr);
     return 1;
 }
@@ -604,5 +605,5 @@
 sub ProcessAdobeIFD($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     return 0 if $$dirInfo{OutFile}; # (can't write this yet)
     my $dataPt = $$dirInfo{DataPt};
@@ -616,8 +617,8 @@
     # parse the mutilated IFD.  This is similar to a TIFF IFD, except:
     # - data follows directly after Count entry in IFD
-    # - byte order of IFD entires is always big-endian, but byte order of data changes
+    # - byte order of IFD entries is always big-endian, but byte order of data changes
     SetByteOrder('MM');     # IFD structure is always big-endian
     my $entries = Get16u($dataPt, $pos + 2);
-    $exifTool->VerboseDir($dirInfo, $entries);
+    $et->VerboseDir($dirInfo, $entries);
     $pos += 4;
 
@@ -632,5 +633,5 @@
         if ($format < 1 or $format > 13) {
             # warn unless the IFD was just padded with zeros
-            $format and $exifTool->Warn(
+            $format and $et->Warn(
                 sprintf("Unknown format ($format) for $$dirInfo{DirName} tag 0x%x",$tagID));
             return 0; # must be corrupted
@@ -641,5 +642,5 @@
         SetByteOrder($dataOrder);   # data stored in native order
         my $val = ReadValue($dataPt, $pos + 8, $formatStr, $count, $size);
-        $exifTool->HandleTag($tagTablePtr, $tagID, $val,
+        $et->HandleTag($tagTablePtr, $tagID, $val,
             Index   => $index,
             DataPt  => $dataPt,
@@ -651,5 +652,5 @@
     }
     if ($index < $entries) {
-        $exifTool->Warn("Truncated $$dirInfo{DirName} directory");
+        $et->Warn("Truncated $$dirInfo{DirName} directory");
         return 0;
     }
@@ -662,7 +663,8 @@
 # Returns: 1 on success, otherwise returns 0 and sets a Warning
 # Notes: data has 6 byte header (2 for byte order and 4 for original offset)
+#        --> or 18 bytes for DNG converted from JPG by Adobe Camera Raw!
 sub ProcessAdobeMakN($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $start = $$dirInfo{DirStart};
@@ -675,11 +677,17 @@
     return 0 unless SetByteOrder(substr($$dataPt, $start, 2));
 
-    $exifTool->VerboseDir($dirInfo) unless $outfile;
+    $et->VerboseDir($dirInfo) unless $outfile;
     my $dataPos = $$dirInfo{DataPos};
-    my $dirStart = $start + 6;  # pointer to maker note directory
-    my $dirLen = $len - 6;
+    my $hdrLen = 6;
+
+    # hack for extra 12 bytes in MakN header of JPEG converted to DNG by Adobe Camera Raw
+    # (4 bytes "00 00 00 01" followed by 8 unknown bytes)
+    $hdrLen += 12 if $len >= 18 and substr($$dataPt, $start+6, 4) eq "\0\0\0\x01";
+
+    my $dirStart = $start + $hdrLen;    # pointer to maker note directory
+    my $dirLen = $len - $hdrLen;
 
     my $hdr = substr($$dataPt, $dirStart, $dirLen < 48 ? $dirLen : 48);
-    my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, 'MakN', \$hdr);
+    my $tagInfo = $et->GetTagInfo($tagTablePtr, 'MakN', \$hdr);
     return 0 unless $tagInfo and $$tagInfo{SubDirectory};
     my $subdir = $$tagInfo{SubDirectory};
@@ -701,12 +709,12 @@
     );
     # look for start of maker notes IFD
-    my $loc = Image::ExifTool::MakerNotes::LocateIFD($exifTool,\%subdirInfo);
+    my $loc = Image::ExifTool::MakerNotes::LocateIFD($et,\%subdirInfo);
     unless (defined $loc) {
-        $exifTool->Warn('Maker notes could not be parsed');
+        $et->Warn('Maker notes could not be parsed');
         return 0;
     }
-    if ($exifTool->Options('HtmlDump')) {
-        $exifTool->HDump($dataPos + $start, 6, 'Adobe MakN data');
-        $exifTool->HDump($dataPos + $dirStart, $loc, "$$tagInfo{Name} header") if $loc;
+    if ($et->Options('HtmlDump')) {
+        $et->HDump($dataPos + $start, $hdrLen, 'Adobe MakN data');
+        $et->HDump($dataPos + $dirStart, $loc, "$$tagInfo{Name} header") if $loc;
     }
 
@@ -721,9 +729,9 @@
         # rewrite the maker notes directory
         my $fixup = $subdirInfo{Fixup} = new Image::ExifTool::Fixup;
-        my $oldChanged = $$exifTool{CHANGED};
-        my $buff = $exifTool->WriteDirectory(\%subdirInfo, $subTable);
+        my $oldChanged = $$et{CHANGED};
+        my $buff = $et->WriteDirectory(\%subdirInfo, $subTable);
         # nothing to do if error writing directory or nothing changed
-        unless (defined $buff and $exifTool->{CHANGED} != $oldChanged) {
-            $exifTool->{CHANGED} = $oldChanged;
+        unless (defined $buff and $$et{CHANGED} != $oldChanged) {
+            $$et{CHANGED} = $oldChanged;
             return 1;
         }
@@ -746,14 +754,14 @@
         $fixup->{Shift} += $loc;    # adjust for makernotes header
         $fixup->ApplyFixup(\$buff); # fix up pointer offsets
-        # get copy of original Adobe header (6) and makernotes header ($loc)
-        my $header = substr($$dataPt, $start, 6 + $loc);
+        # get copy of original Adobe header (6 or 18) and makernotes header ($loc)
+        my $header = substr($$dataPt, $start, $hdrLen + $loc);
         # add Adobe and makernotes headers to new directory
         $$outfile = $header . $buff;
     } else {
         # parse the maker notes directory
-        $exifTool->ProcessDirectory(\%subdirInfo, $subTable, $$subdir{ProcessProc});
+        $et->ProcessDirectory(\%subdirInfo, $subTable, $$subdir{ProcessProc});
         # extract maker notes as a block if specified
-        if ($exifTool->Options('MakerNotes') or
-            $exifTool->{REQ_TAG_LOOKUP}->{lc($$tagInfo{Name})})
+        if ($et->Options('MakerNotes') or
+            $$et{REQ_TAG_LOOKUP}{lc($$tagInfo{Name})})
         {
             my $val;
@@ -764,6 +772,8 @@
                 $subdirInfo{DirLen}   = $dirLen;
                 # rebuild the maker notes to identify all offsets that require fixing up
-                $val = Image::ExifTool::Exif::RebuildMakerNotes($exifTool, $subTable, \%subdirInfo);
-                defined $val or $exifTool->Warn('Error rebuilding maker notes (may be corrupt)');
+                $val = Image::ExifTool::Exif::RebuildMakerNotes($et, \%subdirInfo, $subTable);
+                if (not defined $val and $dirLen > 4) {
+                    $et->Warn('Error rebuilding maker notes (may be corrupt)');
+                }
             } else {
                 # extract this directory as a block if specified
@@ -771,5 +781,5 @@
             }
             $val = substr($$dataPt, 20) unless defined $val;
-            $exifTool->FoundTag($tagInfo, $val);
+            $et->FoundTag($tagInfo, $val);
         }
     }
@@ -783,10 +793,10 @@
 sub WriteAdobeStuff($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    $exifTool or return 1;    # allow dummy access
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;    # allow dummy access
     my $proc = $$dirInfo{Proc} || \&ProcessAdobeData;
     my $buff;
     $$dirInfo{OutFile} = \$buff;
-    &$proc($exifTool, $dirInfo, $tagTablePtr) or undef $buff;
+    &$proc($et, $dirInfo, $tagTablePtr) or undef $buff;
     return $buff;
 }
@@ -811,5 +821,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/DPX.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/DPX.pm	(revision 34921)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/DPX.pm	(revision 34921)
@@ -0,0 +1,236 @@
+#------------------------------------------------------------------------------
+# File:         DPX.pm
+#
+# Description:  Read DPX meta information
+#
+# Revisions:    2013-09-19 - P. Harvey created
+#
+# References:   1) http://www.cineon.com/ff_draft.php
+#               2) Harry Mallon private communication
+#------------------------------------------------------------------------------
+
+package Image::ExifTool::DPX;
+
+use strict;
+use vars qw($VERSION);
+use Image::ExifTool qw(:DataAccess :Utils);
+
+$VERSION = '1.05';
+
+# DPX tags
+%Image::ExifTool::DPX::Main = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'File', 1 => 'File', 2 => 'Image' },
+    NOTES => 'Tags extracted from DPX (Digital Picture Exchange) images.',
+    0   => { Name => 'ByteOrder',     Format => 'undef[4]', PrintConv => { SDPX => 'Big-endian', XPDS => 'Little-endian' } },
+    8   => { Name => 'HeaderVersion', Format => 'string[8]' },
+    # 24 => { Name => 'GenericHeaderSize', Format => 'int32u' }, # = 1664
+    # 28 => { Name => 'IndustryStandardHeaderSize', Format => 'int32u' }, # = 384
+    16  => { Name => 'DPXFileSize',   Format => 'int32u' },
+    20  => { Name => 'DittoKey',      Format => 'int32u', PrintConv => { 0 => 'Same', 1 => 'New' } },
+    36  => { Name => 'ImageFileName', Format => 'string[100]' },
+    136 => {
+        Name => 'CreateDate',
+        Format => 'string[24]',
+        Groups => { 2 => 'Time' },
+        ValueConv => '$val =~ s/(\d{4}:\d{2}:\d{2}):/$1 /; $val',
+        PrintConv => '$self->ConvertDateTime($val)',
+    },
+    160 => { Name => 'Creator',       Format => 'string[100]', Groups => { 2 => 'Author' } },
+    260 => { Name => 'Project',       Format => 'string[200]' },
+    460 => { Name => 'Copyright',     Format => 'string[200]', Groups => { 2 => 'Author' } },
+    660 => { Name => 'EncryptionKey', Format => 'int32u', PrintConv => 'sprintf("%.8x",$val)' },
+    768 => {
+        Name => 'Orientation',
+        Format => 'int16u',
+        PrintConv => {
+            0 => 'Horizontal (normal)',
+            1 => 'Mirror vertical',
+            2 => 'Mirror horizontal',
+            3 => 'Rotate 180',
+            4 => 'Mirror horizontal and rotate 270 CW',
+            5 => 'Rotate 90 CW',
+            6 => 'Rotate 270 CW',
+            7 => 'Mirror horizontal and rotate 90 CW',
+        },
+    },
+    770 => { Name => 'ImageElements', Format => 'int16u' },
+    772 => { Name => 'ImageWidth',    Format => 'int32u' },
+    776 => { Name => 'ImageHeight',   Format => 'int32u' },
+    780 => { Name => 'DataSign',      Format => 'int32u', PrintConv => { 0 => 'Unsigned', 1 => 'Signed' } },
+    800 => {
+        Name => 'ComponentsConfiguration',
+        Format => 'int8u',
+        PrintConv => {
+            0 => 'User-defined single component',
+            1 => 'Red (R)',
+            2 => 'Green (G)',
+            3 => 'Blue (B)',
+            4 => 'Alpha (matte)',
+            6 => 'Luminance (Y)',
+            7 => 'Chrominance (Cb, Cr, subsampled by two)',
+            8 => 'Depth (Z)',
+            9 => 'Composite video',
+            50 => 'R, G, B',
+            51 => 'R, G, B, Alpha',
+            52 => 'Alpha, B, G, R',
+            100 => 'Cb, Y, Cr, Y (4:2:2)',
+            101 => 'Cb, Y, A, Cr, Y, A (4:2:2:4)',
+            102 => 'Cb, Y, Cr (4:4:4)',
+            103 => 'Cb, Y, Cr, A (4:4:4:4)',
+            150 => 'User-defined 2 component element',
+            151 => 'User-defined 3 component element',
+            152 => 'User-defined 4 component element',
+            153 => 'User-defined 5 component element',
+            154 => 'User-defined 6 component element',
+            155 => 'User-defined 7 component element',
+            156 => 'User-defined 8 component element',
+        },
+    },
+    801 => { #2
+        Name => 'TransferCharacteristic',
+        Format => 'int8u',
+        PrintConv => {
+            0 => 'User-defined',
+            1 => 'Printing density',
+            2 => 'Linear',
+            3 => 'Logarithmic',
+            4 => 'Unspecified video',
+            5 => 'SMPTE 274M',
+            6 => 'ITU-R 704-4',
+            7 => 'ITU-R 601-5 system B or G (625)',
+            8 => 'ITU-R 601-5 system M (525)',
+            9 => 'Composite video (NTSC)',
+            10 => 'Composite video (PAL)',
+            11 => 'Z (depth) - linear',
+            12 => 'Z (depth) - homogeneous',
+            13 => 'SMPTE ADX',
+            14 => 'ITU-R 2020 NCL',
+            15 => 'ITU-R 2020 CL',
+            16 => 'IEC 61966-2-4 xvYCC',
+            17 => 'ITU-R 2100 NCL/PQ',
+            18 => 'ITU-R 2100 ICtCp/PQ',
+            19 => 'ITU-R 2100 NCL/HLG',
+            20 => 'ITU-R 2100 ICtCp/HLG',
+            21 => 'RP 431-2:2011 Gama 2.6',
+            22 => 'IEC 61966-2-1 sRGB',
+        },
+    },
+    802 => { #2
+        Name => 'ColorimetricSpecification',
+        Format => 'int8u',
+        PrintConv => {
+            0 => 'User-defined',
+            1 => 'Printing density',
+            4 => 'Unspecified video',
+            5 => 'SMPTE 274M',
+            6 => 'ITU-R 704-4',
+            7 => 'ITU-R 601-5 system B or G (625)',
+            8 => 'ITU-R 601-5 system M (525)',
+            9 => 'Composite video (NTSC)',
+            10 => 'Composite video (PAL)',
+            13 => 'SMPTE ADX',
+            14 => 'ITU-R 2020',
+            15 => 'P3D65',
+            16 => 'P3DCI',
+            17 => 'P3D60',
+            18 => 'ACES',
+        },
+    },
+    803 => { Name => 'BitDepth',      Format => 'int8u' },
+    820 => { Name => 'ImageDescription',  Format => 'string[32]' },
+    892 => { Name => 'Image2Description', Format => 'string[32]', RawConv => '$val=~/[^\xff]/ ? $val : undef' },
+    964 => { Name => 'Image3Description', Format => 'string[32]', RawConv => '$val=~/[^\xff]/ ? $val : undef' },
+    1036=> { Name => 'Image4Description', Format => 'string[32]', RawConv => '$val=~/[^\xff]/ ? $val : undef' },
+    1108=> { Name => 'Image5Description', Format => 'string[32]', RawConv => '$val=~/[^\xff]/ ? $val : undef' },
+    1180=> { Name => 'Image6Description', Format => 'string[32]', RawConv => '$val=~/[^\xff]/ ? $val : undef' },
+    1252=> { Name => 'Image7Description', Format => 'string[32]', RawConv => '$val=~/[^\xff]/ ? $val : undef' },
+    1324=> { Name => 'Image8Description', Format => 'string[32]', RawConv => '$val=~/[^\xff]/ ? $val : undef' },
+    # 1408=> { Name => 'XOffset',           Format => 'int32u' },
+    # 1412=> { Name => 'YOffset',           Format => 'int32u' },
+    # 1416=> { Name => 'XCenter',           Format => 'float' },
+    # 1420=> { Name => 'YCenter',           Format => 'float' },
+    # 1424=> { Name => 'XOriginalSize',     Format => 'int32u' },
+    # 1428=> { Name => 'YOriginalSize',     Format => 'int32u' },
+    1432=> { Name => 'SourceFileName',    Format => 'string[100]' },
+    1532=> { Name => 'SourceCreateDate',  Format => 'string[24]' },
+    1556=> { Name => 'InputDeviceName',   Format => 'string[32]' },
+    1588=> { Name => 'InputDeviceSerialNumber', Format => 'string[32]' },
+    # 1620=> { Name => 'AspectRatio',       Format => 'int32u' },
+    1724 => { Name => 'OriginalFrameRate',Format => 'float' },
+    1728 => { Name => 'ShutterAngle',     Format => 'float', RawConv => '($val =~ /\d/ and $val !~ /nan/i) ? $val : undef' }, #2
+    1732 => { Name => 'FrameID',          Format => 'string[32]' },
+    1764 => { Name => 'SlateInformation', Format => 'string[100]' },
+    1920 => { Name => 'TimeCode',         Format => 'int32u' }, #2
+    1940 => { Name => 'FrameRate',        Format => 'float', RawConv => '($val =~ /\d/ and $val !~ /nan/i) ? $val : undef' }, #2
+    1972 => { Name => 'Reserved5',        Format => 'string[76]', Unknown => 1 },
+    2048 => { Name => 'UserID',           Format => 'string[32]' },
+);
+
+#------------------------------------------------------------------------------
+# Extract EXIF information from a DPX image
+# Inputs: 0) ExifTool object reference, 1) dirInfo reference
+# Returns: 1 on success, 0 if this wasn't a valid DPX file
+sub ProcessDPX($$)
+{
+    my ($et, $dirInfo) = @_;
+    my $raf = $$dirInfo{RAF};
+    my $buff;
+
+    # verify this is a valid DPX file
+    return 0 unless $raf->Read($buff, 2080) == 2080;
+    return 0 unless $buff =~ /^(SDPX|XPDS)/;
+    SetByteOrder($1 eq 'SDPX' ? 'MM' : 'II');
+    $et->SetFileType();   # set the FileType tag
+    my $hdrLen = Get32u(\$buff,24) + Get32u(\$buff,28);
+    $hdrLen == 2048 or $et->Warn("Unexpected DPX header length ($hdrLen)");
+    my %dirInfo = (
+        DataPt => \$buff,
+        DirStart => 0,
+        DirLen => length($buff),
+    );
+    my $tagTablePtr = GetTagTable('Image::ExifTool::DPX::Main');
+    $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
+
+    return 1;
+}
+
+1;  # end
+
+__END__
+
+=head1 NAME
+
+Image::ExifTool::DPX - Read DPX meta information
+
+=head1 SYNOPSIS
+
+This module is used by Image::ExifTool
+
+=head1 DESCRIPTION
+
+This module contains definitions required by Image::ExifTool to read
+metadata from DPX (Digital Picture Exchange) images.
+
+=head1 AUTHOR
+
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
+
+This library is free software; you can redistribute it and/or modify it
+under the same terms as Perl itself.
+
+=head1 REFERENCES
+
+=over 4
+
+=item L<http://www.cineon.com/ff_draft.php>
+
+=back
+
+=head1 SEE ALSO
+
+L<Image::ExifTool::TagNames/DPX Tags>,
+L<Image::ExifTool(3pm)|Image::ExifTool>
+
+=cut
+
